include \masm32\include\masm32rt.inc
; include \masm32\MasmBasic\MasmBasic.inc 

.data?
LowStack	dd ?
OldStack	dd ?

.code
start:
	invoke GetModuleHandle, 0
	ASSUME fs:NOTHING
	mov edx, fs:[4]		; Win32 Thread Information Block (TIB), 2nd DWORD: Top of Stack
	xchg eax, esi
	mov eax, [esi.IMAGE_DOS_HEADER.e_lfanew]	; D0
	mov eax, [esi+eax+IMAGE_NT_HEADERS.OptionalHeader+IMAGE_OPTIONAL_HEADER.SizeOfStackReserve]
	sub edx, eax
	add edx, 3000h
	mov LowStack, edx
	print hex$(LowStack), 9, " is the lowest address", 13, 10
	mov eax, fs:[4]
	ASSUME fs:ERROR
	print hex$(eax), 9, " initial top of the stack", 13, 10
	mov eax, esp
	print hex$(eax), 9, " current top of the stack", 13, 10
	xor edi, edi
	mov ebx, LowStack
	add ebx, 40
	mov esi, esp
	.Repeat
		push eax
		add edi, 4
		.if esp<ebx		; show last ten entries for Win XP
			mov eax, esp
			xchg esp, esi
			print hex$(eax), 13, 10
			xchg esp, esi
		.endif
	.Until esp<=LowStack		; decimal 208896
	xchg esp, esi
	inkey "OK, no overflow", 13, 10, "Hit a key to see it crash, or Ctrl C to exit: "
;	int 3
	xchg esp, esi
	push eax
	pop eax	
	xchg esp, esi
	inkey "If you see this, the proggie did not work as it should"
exit
end start

OxPT_DebugL	/stack:2097152	; 200000h
OxPT_DebugL	/stack:4194304	; 400000h
OPT_DebugL	/stack:5242880	; 500000h
OxPT_DebugL	/stack:16777216	; $1000000
OPT_Linker	link
OPT_Wait	1
OPT_DelTmp	0
OPT_DelObj	0
OPT_Tmp2Asm	1


004B3000         is the lowest address
009B0000         initial top of the stack
009AFFC4         current top of the stack
004B3024
004B3020
004B301C
004B3018
004B3014
004B3010
004B300C
004B3008
004B3004
004B3000
OK, no overflow
Hit a key to see it crash:
If you see this, the proggie did not work as it should
(red part visible in Olly)